--------------------------------------------------------------------------------
-- GLOBALS
--------------------------------------------------------------------------------
Global( "wtMainPanel", nil )
Global( "wtMainPanelDNDId", 0 )
Global( "bMainPanelMovable", false )

Global( "wtButton1", nil )

Global( "wtDetailPnel", nil )

Global( "wtSpellInfoTextView1", nil )
Global( "wtSpellInfoTextView2", nil )
Global( "wtSpellInfoTextView3", nil )
Global( "wtSpellInfoTextView4", nil )
Global( "wtSpellInfoTextView5", nil )
Global( "wtSpellInfoTextView6", nil )
Global( "wtSpellInfoTextView7", nil )
Global( "wtSpellInfoTextView8", nil )
Global( "wtSpellInfoTextView9", nil )
Global( "wtSpellInfoTextView10", nil )
Global( "wtSpellInfoTextView11", nil )
Global( "wtSpellInfoTextView12", nil )
Global( "wtSpellInfoTextView13", nil )

Global( "DamageData", {
	["SpellsData"] = {},
	["DamageAmount"] = 0,
	["FightTime"] = 0,
	["bCollectData"] = false
} )
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function SetDPSMeterValues()
	local PlayerName = object.GetName( avatar.GetId() )
	wtButton1:SetVal( "Index", common.FormatFloat( 1 , "%d" ) )
	wtButton1:SetVal( "Name",  PlayerName )
	wtButton1:SetVal( "DamageDone", common.FormatFloat( DamageData["DamageAmount"] , "%f3K5" ) )
	wtButton1:SetVal( "DPS", common.FormatFloat( (DamageData["DamageAmount"] / DamageData["FightTime"]), "%f3K5" ) )
end
function SetSpellInfoDataToTextView( SpellDataInfo, wtTextView, index )
	wtTextView:Show(true)
	wtTextView:SetVal( "Index", common.FormatFloat( index , "%d" ) )
	wtTextView:SetVal( "Name", SpellDataInfo["Name"] )
	wtTextView:SetVal( "DamageDone", common.FormatFloat( SpellDataInfo[ "HitDamageDone" ] , "%f3K5" ) )
	wtTextView:SetVal( "DPS", common.FormatFloat( (SpellDataInfo[ "HitDamageDone" ] / DamageData["FightTime"]) , "%f3K5" ) )
	wtTextView:SetVal( "Percentage", common.FormatFloat( SpellDataInfo[ "HitDamageDonePercentage" ] , "%.1f" ) )
end
function UpdateDamageDetails()
	local index = 0
	for i, SpellDataInfo in DamageData["SpellsData"] do
		index = index + 1
		if index == 1 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView1, index )
		elseif index == 2 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView2, index )
		elseif index == 3 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView3, index )
		elseif index == 4 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView4, index )
		elseif index == 5 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView5, index )
		elseif index == 6 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView6, index )
		elseif index == 7 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView7, index )
		elseif index == 8 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView8, index )
		elseif index == 9 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView9, index )
		elseif index == 10 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView10, index )
		elseif index == 11 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView11, index )
		elseif index == 12 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView12, index )
		elseif index == 13 then 
			SetSpellInfoDataToTextView( SpellDataInfo, wtSpellInfoTextView13, index )

		end
	end

	local DetailPanelPlacement = wtDetailPnel:GetPlacementPlain()

	if index > 0 then 
		DetailPanelPlacement.sizeY = (index + 2) * 18
	else
		DetailPanelPlacement.sizeY = 0
	end;
	wtDetailPnel:SetPlacementPlain( DetailPanelPlacement )
end
function HideAllDamageDetails()
	wtSpellInfoTextView1:Show(false)
	wtSpellInfoTextView2:Show(false)
	wtSpellInfoTextView3:Show(false)
	wtSpellInfoTextView4:Show(false)
	wtSpellInfoTextView5:Show(false)
	wtSpellInfoTextView6:Show(false)
	wtSpellInfoTextView7:Show(false)
	wtSpellInfoTextView8:Show(false)
	wtSpellInfoTextView9:Show(false)
	wtSpellInfoTextView10:Show(false)
	wtSpellInfoTextView11:Show(false)
	wtSpellInfoTextView12:Show(false)
	wtSpellInfoTextView13:Show(false)
end
--------------------------------------------------------------------------------
function MoveAllUIElements( posX, posY )
	local MainPanelPlacement = wtMainPanel:GetPlacementPlain()
	local ButtonPlacement = wtButton1:GetPlacementPlain()
	local DetailPanelPlacement = wtDetailPnel:GetPlacementPlain()

	MainPanelPlacement.posX = posX
	MainPanelPlacement.posY = posY
	wtMainPanel:SetPlacementPlain( MainPanelPlacement )

	ButtonPlacement.posX = MainPanelPlacement.posX
	ButtonPlacement.posY = MainPanelPlacement.posY + 32
	wtButton1:SetPlacementPlain( ButtonPlacement )

	DetailPanelPlacement.posX = MainPanelPlacement.posX
	DetailPanelPlacement.posY = MainPanelPlacement.posY + 64
	wtDetailPnel:SetPlacementPlain( DetailPanelPlacement )
end
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- EVENT HANDLERS
--------------------------------------------------------------------------------
function onCreateAvatar( params )
	SetDPSMeterValues()
	UpdateDamageDetails()
end
--------------------------------------------------------------------------------
function OnEventSecondTimer( params )
	if ( DamageData["bCollectData"] ) then
		DamageData["FightTime"] = DamageData["FightTime"] + 1
		SetDPSMeterValues()
		UpdateDamageDetails()
	end
end
--------------------------------------------------------------------------------
function onAvatarCombatStatusChanged( params )
	if params.inCombat then 
		DamageData["DamageAmount"] = 0
		DamageData["FightTime"] = 0
		DamageData["SpellsData"] = 0
		DamageData["SpellsData"] = {}
		DamageData["bCollectData"] = true
		HideAllDamageDetails()
	else
		DamageData["bCollectData"] = false
		SetDPSMeterValues()
		UpdateDamageDetails()
	end
end
--------------------------------------------------------------------------------
function FindSpellDataInfo( debugName )

	for i, SpellDataInfo in DamageData["SpellsData"] do
		
		if ( SpellDataInfo[ "SysName" ] == debugName ) then 
			return SpellDataInfo
		end
	end
	return nil

end
--------------------------------------------------------------------------------
function onDamageReceived( params )
	
	if params then
		if (params.source) and ( params.source == avatar.GetId() ) and ( params.target ~=  avatar.GetId() ) then

			if (params.amount) and ( not params.isFall )  then 

				DamageData["DamageAmount"] = DamageData["DamageAmount"] + params.amount

				local spellInfo
				
				if params.spellId then 
					spellInfo = avatar.GetSpellInfo( params.spellId )
				elseif params.buffId then
					spellInfo = avatar.GetBuffInfoById( params.buffId )
				end

				local SpellDataInfo = FindSpellDataInfo( spellInfo.debugName )

				if ( SpellDataInfo == nil ) then
					SpellDataInfo = {}
					SpellDataInfo[ "Name" ]  = ""
					SpellDataInfo[ "SpellID" ] = 0
					SpellDataInfo[ "AbilityID" ] = 0
					SpellDataInfo[ "BuffID" ] = 0
					SpellDataInfo[ "SysName" ] = ""
					SpellDataInfo[ "HitCount" ] = 0
					SpellDataInfo[ "HitDamageDone" ] = 0
					SpellDataInfo[ "HitDamageDonePercentage" ] = 0
				end
				
				SpellDataInfo[ "Name" ]  = params.ability
				SpellDataInfo[ "SpellID" ] = params.spellId
				SpellDataInfo[ "AbilityID" ] = params.abilityId
				SpellDataInfo[ "BuffID" ] = params.buffId

				SpellDataInfo[ "SysName" ] = spellInfo.debugName

				SpellDataInfo[ "HitCount" ] = SpellDataInfo[ "HitCount" ] + 1
				SpellDataInfo[ "HitDamageDone" ] =  SpellDataInfo[ "HitDamageDone" ] + params.amount
				SpellDataInfo[ "HitDamageDonePercentage" ] = SpellDataInfo[ "HitDamageDone" ] / ( DamageData["DamageAmount"] / 100 ) 

				--if ( not params.isCritical ) then
				--	SpellDataInfo[ "HitCount" ] = 1
				--	SpellDataInfo[ "HitDamageDone" ] =  params.amount
				--elseif ( params.isCritical ) then
				--	SpellDataInfo[ "CritCount" ] =  1
				--	SpellDataInfo[ "CritDamageDone" ] =  params.amount
				--end

				DamageData["SpellsData"][ spellInfo.debugName ] = SpellDataInfo

				SetDPSMeterValues()
				UpdateDamageDetails()
			end
		elseif (params.source) and ( unit.IsPet( params.source ) ) and ( unit.GetPetOwner( params.source ) ==  avatar.GetId() ) then
			if params.amount then 
				DamageData["DamageAmount"] = DamageData["DamageAmount"] + params.amount
				SetDPSMeterValues()
				UpdateDamageDetails()
			end
		end
	end
end
--------------------------------------------------------------------------------
function OnButton1Reaction(params)
	local visible = wtDetailPnel:IsVisible()
	if visible then 
		wtDetailPnel:Show(false)
	else
		wtDetailPnel:Show(true)		
	end
		
end
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function OnEventDNDPickAttempt( params )
	if params.srcId == wtMainPanelDNDId then 
		bMainPanelMovable = true
	else
		bMainPanelMovable = false
	end
end
function OnEventDNDDragTo( params )
	if bMainPanelMovable then
		MoveAllUIElements( params.posX, params.posY )
	end
end
function OnEventDNDDropAttempt( params )	
	bMainPanelMovable = false
	mission.DNDConfirmDropAttempt()
end
function GetDNDId( container, item )
	wtMainPanelDNDId = container * DND_CONTAINER_STEP + item
	return wtMainPanelDNDId
end
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	common.RegisterEventHandler( OnEventSecondTimer, "EVENT_SECOND_TIMER" ) 
	common.RegisterEventHandler( onDamageReceived, "EVENT_UNIT_DAMAGE_RECEIVED" )
	common.RegisterEventHandler( onAvatarCombatStatusChanged, "EVENT_AVATAR_COMBAT_STATUS_CHANGED" )
	common.RegisterEventHandler( onCreateAvatar, "EVENT_AVATAR_CREATED" )
	common.RegisterEventHandler( OnEventDNDDragTo, "EVENT_DND_DRAG_TO" )
	common.RegisterEventHandler( OnEventDNDDropAttempt, "EVENT_DND_DROP_ATTEMPT" )
	common.RegisterEventHandler( OnEventDNDPickAttempt, "EVENT_DND_PICK_ATTEMPT" )

	wtMainPanel = mainForm:GetChildChecked( "MainPanel", false )
	wtMainPanel:Show(true)
	mission.DNDRegister( wtMainPanel, GetDNDId( DND_WIDGET_MOVE, 668 ), false )

	wtDetailPnel = mainForm:GetChildChecked( "DetailPanel", false )
	wtDetailPnel:Show(true)

	wtButton1 = mainForm:GetChildChecked( "Button1", false )
	common.RegisterReactionHandler( OnButton1Reaction, "Button1Reaction" )	

	wtSpellInfoTextView1 = wtDetailPnel:GetChildChecked( "SpellInfo1", false )
	wtSpellInfoTextView2 = wtDetailPnel:GetChildChecked( "SpellInfo2", false )
	wtSpellInfoTextView3 = wtDetailPnel:GetChildChecked( "SpellInfo3", false )
	wtSpellInfoTextView4 = wtDetailPnel:GetChildChecked( "SpellInfo4", false )
	wtSpellInfoTextView5 = wtDetailPnel:GetChildChecked( "SpellInfo5", false )
	wtSpellInfoTextView6 = wtDetailPnel:GetChildChecked( "SpellInfo6", false )
	wtSpellInfoTextView7 = wtDetailPnel:GetChildChecked( "SpellInfo7", false )
	wtSpellInfoTextView8 = wtDetailPnel:GetChildChecked( "SpellInfo8", false )
	wtSpellInfoTextView9 = wtDetailPnel:GetChildChecked( "SpellInfo9", false )
	wtSpellInfoTextView10 = wtDetailPnel:GetChildChecked( "SpellInfo10", false )
	wtSpellInfoTextView11 = wtDetailPnel:GetChildChecked( "SpellInfo11", false )
	wtSpellInfoTextView12 = wtDetailPnel:GetChildChecked( "SpellInfo12", false )
	wtSpellInfoTextView13 = wtDetailPnel:GetChildChecked( "SpellInfo13", false )

	HideAllDamageDetails()

	MoveAllUIElements( 20, 200 )

end
--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------
